from Products.CMFCore.utils import UniqueObject 
from Products.CMFCore.utils import getToolByName
from OFS.Folder import Folder
from Globals import InitializeClass 
from Products.CMFCore.ActionProviderBase import ActionProviderBase

import string


class EnhancedCounterTool (UniqueObject, Folder, ActionProviderBase): 
    """ PloneEnhancedCounter Tool """ 
    id = 'portal_enhanced_counter' 
    meta_type= 'PloneEnhancedCounter Tool' 
    plone_tool = 1 

    _actions = ( )

    _properties=(
        {'id':'portal_prefix','type':'string'},
    ) 
    portal_prefix = 'portal'

    manage_options = ( tuple([{'label':'Properties',
                         'action':'manage_propertiesForm'}] ) + ActionProviderBase.manage_options)

        
    def getCounterPath(self, obj):
        try:
            return_path = '/' + str(obj.UID())
        except:
            portal = self.portal_url.getPortalObject()
            relative_parents = []
            parents = obj.REQUEST.PARENTS
            return_path = ''
            path_info = string.split(str(obj.REQUEST.PATH_INFO), '/')

            if obj.id == path_info[-1]:
                relative_parents.append(str(obj.id))

            for parent in parents[:-1]:
	
                if parent == portal:
                    break

                relative_parents.append(str(parent.id))

            relative_parents.reverse()
            try:
                if relative_parents[-1] == 'index_html':
                    relative_parents = relative_parents[:-1]

                for parent in relative_parents:
                    return_path = return_path + '/' + str(parent)
            except:
                return_path = '/'

        if not return_path:
            return_path = '/'

        return '/' + str(self.portal_prefix) + return_path

    def configure_enhanced_counter(self, portal_prefix,REQUEST=None):
        try:
            self.portal_prefix=portal_prefix
            if REQUEST:
                REQUEST.RESPONSE.redirect(self.absolute_url() + '/prefs_enhanced_counter')
        except:
            if REQUEST:
                REQUEST.RESPONSE.redirect(self.absolute_url() + '/prefs_enhanced_counter?portal_status_message=Error trying to setup the new configuration.')




InitializeClass(EnhancedCounterTool) 
