from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.PloneEnhancedCounter import GLOBALS
from cStringIO import StringIO
import string

counter_configlet = {
    'id': 'PloneEnhancedCounter',
    'appId': 'PloneEnhancedCounter',
    'name': 'PloneEnhancedCounter configuration',
    'action': 'string:$portal_url/portal_enhanced_counter/prefs_enhanced_counter',
    'category': 'Products',
    'permission': ('Manage Portal',),
    'imageUrl': 'topic_icon.gif',
    }

def install(self):
    " Register the CMF ReportTool with portal_types and friends "
    out = StringIO()
    portal = getToolByName(self,'portal_url').getPortalObject()

    skinstool = getToolByName(self, 'portal_skins')


    if 'PloneEnhancedCounter' not in skinstool.objectIds():

		addDirectoryViews(skinstool, 'skins', GLOBALS)
		out.write("Added 'PloneEnhancedCounter' directory view to portal_skins\n")


    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'PloneEnhancedCounter' not in path:
            try:
                path.insert(path.index( 'custom')+1, 'PloneEnhancedCounter')
            except ValueError:
                path.append('PloneEnhancedCounter')
				
            path = string.join(path, ', ')

            skinstool.addSkinSelection(skin, path)
            out.write("Added 'PloneEnhancedCounter' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'PloneEnhancedCounter' is already set up\n" % (skin))



    try:
        addTool = self.manage_addProduct['PloneEnhancedCounter'].manage_addTool
        addTool('PloneEnhancedCounter Tool', None)
        out.write("Tool added\n")
    except:
        out.write("Tool skiped\n")
        pass

    try:
        pa = getToolByName(self, 'portal_actions')
        isActionDefined=0
        pa.addAction(
                     'set_enhanced_counter',
                     'Set Counter',
                     'string:$object_url/enhanced_counter_edit_form',
                     '',
                     'Manage portal',
                     'object'
                    )
        installation.out.write('New action tab added.\n')
    except:
        out.write("Erro adding the new action tab\n")
        pass



    try:
        self.portal_controlpanel.registerConfiglet(**counter_configlet)
        out.write("Added configlet to controlpanel.\n")
    except:
        out.write("*** Couldn't add configlet to controlpanel.\n")

    return out.getvalue()